﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=12.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
#End Region

Sub Process_Globals
	'Private nid As Int = 1
	Private GPS As GPS
	Private Tracking As Boolean
	Private LastUpdateTime As Long
	Private lock As PhoneWakeState
	Dim Distance As Double
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	GPS.Initialize("gps")
	lock.PartialLock
End Sub

Sub Service_Start (StartingIntent As Intent)
	'Service.StartForeground(nid, CreateNotification("..."))
	Track
End Sub

Public Sub Track
	'Sleep(0)
	If Tracking Then Return
	If Starter.rp.Check(Starter.rp.PERMISSION_ACCESS_FINE_LOCATION) = False Then
		Log("No permission")
		Return
	End If
	GPS.Start(0, 0)
	Tracking = True
End Sub

Sub GPS_LocationChanged (Location1 As Location)
	If DateTime.Now > LastUpdateTime + 10 * DateTime.TicksPerSecond Then
		'Dim n As Notification = CreateNotification($"$2.8{Location1.Latitude} / $2.8{Location1.Longitude}"$)
		'n.Notify(nid)
		LastUpdateTime = DateTime.Now
		CheckDistance (Location1)
	End If
End Sub

Sub Service_Destroy
	If Tracking Then
		GPS.Stop
	End If
	Tracking = False
	lock.ReleasePartialLock
End Sub

Sub CheckDistance(Location1 As Location)
	Dim Location2 As Location
	Dim TrueCount As Byte = 0
		Dim b As Beeper
	b.Initialize(300, 500) 'Initialize (Duration As Int, Frequency As Int)
	'b.beep
	For x = 0 To Main.LastContext
		'Calculate distances to each context (location) that has a lat/lon.
		If Main.Contexts(x,2) <> "" Then 'Some contexts have no lat or lon.  Can't use them.
			
			'Find the distance from each context to the phone.
			Location2.Initialize2(Main.Contexts(x,2),Main.Contexts(x,3))
			Distance =  Location1.DistanceTo(Location2) * .00062137 'miles.
			Distance = Round2(Distance, 2)
			'ToastMessageShow (Main.Contexts(X,0)&": " & Distance & " miles.", True)
			
			'Check to see if the distance to the context is within the specifed distance to be considered "close".
			'Make a map of those that are close.
			If Distance < Main.Contexts(x,4) Then 'Context is Close.
				Main.Contexts(x,5) = 1
				'Log("Close Context = "&Main.Contexts(x,0))
				TrueCount = TrueCount + 1
				'ToastMessageShow("Close to " & Main.Contexts(x,0),True)
			Else 'Context is not close.
				Main.Contexts(x,5) = 0 'Clear close contexts from Context array.
 				Main.Contexts(x,6) = 0 'Clear desired contexts from Context array.
			End If
		End If
	Next
		
	If TrueCount > 0 Then 'Some of the contexts are close.
		Main.Close = True
		If Main.NotificationAllowed = True Then
			b.Beep  'Play a sound and show a message to let the user know.  A notification will also be raised in the Main activity.
		End If
		Log("MenuBuilt = "&Main.MenuBuilt)
		If Main.MenuBuilt = False Then
			CallSubDelayed(Main,"BuildMenuMap")
			Main.MenuBuilt = True
		End If
	Else
		Main.Close = False
		Main.NotificationAllowed = True
	End If
	'Log("TrueCount = "&TrueCount)
	'Log("Close = "&Main.Close)
End Sub